var easy2map_map_functions = (function() {

    displayGoogleMap = function(allowMapZoom) {

        var settings = jQuery.xml2json($mapSettings.Settings);
        var $lat = settings.lattitude;
        var $lng = settings.longitude;
        var $zoom = parseInt(settings.zoom);

        if (typeof allowMapZoom != "undefined"){
            allowMapZoom = allowMapZoom;
        } else {
            allowMapZoom = true;
        }

        if ($map != null) {
            $lat = $map.getCenter().lat();
            $lng = $map.getCenter().lng();
            $zoom = $map.getZoom();
        }

        var mapOptions = retrieveMapOptions($lat, $lng, $zoom);

        $map = new google.maps.Map(document.getElementById("divMap"), mapOptions);
        var isDraggable = jQuery(document).width() > 480 ? true : $allowMapZoom;
        $map.setOptions({draggable : isDraggable, zoomControl: allowMapZoom, scrollwheel: allowMapZoom, 
            disableDoubleClickZoom: allowMapZoom});

        $overlay = new google.maps.OverlayView();
        $overlay.draw = function() {
        };
        $overlay.setMap($map);

        if (mapOptions.trafficlayer) {
            var trafficLayer = new google.maps.TrafficLayer();
            trafficLayer.setMap($map);
        }

        if (mapOptions.transitlayer) {
            var transitLayer = new google.maps.TransitLayer();
            transitLayer.setMap($map);
        }

        if (mapOptions.bicyclelayer) {
            var bicycleLayer = new google.maps.BicyclingLayer();
            bicycleLayer.setMap($map);
        }

    };

    //change 'border_width' into 'Border Width', for example
    normaliseCSSElement = function(item) {
        item = replaceAll(item, "_", " ");
        item = item.toLowerCase().replace(/\b[a-z]/g, function(letter) {
            return letter.toUpperCase();
        });
        return item;
    };

    //refresh the example map
    refreshExampleMap = function(saveMapToDatabase) {

        var templateID = parseInt(jQuery("#MapTemplateName").val());

        for (var t = 0; t < $arrTemplates.length; t++) {

            var template = $arrTemplates[t];

            if (parseInt(template.ID) == templateID) {

                jQuery('#divPreview').html(replaceAll(template.TemplateHTML, '[siteurl]', $pluginsURL));

                if (parseInt(template.StyleParentOnly) === 0) {

                    jQuery('[id ^= styleElement]').each(function() {
                        jQuery('#divMap').css(replaceAll(jQuery(this).attr('item'), "_", "-"), jQuery(this).attr('value'));
                    });

                } else {

                    jQuery('[id ^= styleElement]').each(function() {

                        if (jQuery(this).attr('item') === "height") {

                            if (!!jQuery("#divPinList2")) {
                                jQuery('#divMap').css(replaceAll(jQuery(this).attr('item'), "_", "-"), jQuery(this).attr('value'));
                            } else {

                                jQuery("#divMap").height('200px');
                                jQuery("#divPinList").height('186px');
                            }
                        }

                        jQuery('#divMapParent').css(replaceAll(jQuery(this).attr('item'), "_", "-"), jQuery(this).attr('value'));
                    });

                    if (!!jQuery("#divPinList2") === false) {
                        jQuery("#divMap").height(jQuery("#divMapParent").height());
                        jQuery("#divPinList").height(jQuery("#divMapParent").height() - 14);
                    }

                    jQuery("#easy2mapIimgShadow").width(jQuery("#divMapParent").width());
                    jQuery("#easy2mapIimgShadow").width(jQuery("#divMapParent").width());
                    jQuery("#ulEasy2MapPinList").width(jQuery("#divMapParent").width());
                    jQuery("#divMapHeading").html(jQuery('#mapName2').html() === "" ? "Untitled Map" : jQuery('#mapName2').html());
                    //jQuery("#easy2mapIimgShadow").css('marginLeft', jQuery("#divMapParent").css('marginLeft'));
                    //jQuery("#easy2mapIimgShadow").css('marginRight', jQuery("#divMapParent").css('marginRight'));
                }

                jQuery('[id ^= styleList]').each(function() {
                    jQuery('#divPinList').css(replaceAll(jQuery(this).attr('item'), "_", "-"), jQuery(this).attr('value'));
                    jQuery('#divPinList2').css(replaceAll(jQuery(this).attr('item'), "_", "-"), jQuery(this).attr('value'));
                });

                jQuery('[id ^= styleHeading]').each(function() {
                    jQuery('#divMapHeading').css(replaceAll(jQuery(this).attr('item'), "_", "-"), jQuery(this).attr('value'));
                });
            }
        }

        //save the map to the database if required to do so
        if (!!saveMapToDatabase) {

            easy2map_map_functions.saveMap(false, false);

        }

        displayGoogleMap(jQuery('#allowMapZoom').prop("checked"));

        google.maps.event.addDomListener(window, 'load', 
            easy2map_mappin_functions.retrieveMapPoints());

    };

    //retrieve map heading CSS elements for saving to the database
    retrieveHeadingCSS = function() {

        var arrCSS = [];

        jQuery('[id ^= styleHeading]').each(function() {
            var item = replaceAll(jQuery(this).attr('item'), "_", "-");
            arrCSS[item] = jQuery(this).attr('value');
        });

        var options = {
            formatOutput: true,
            rootTagName: 'settings'
        };
        return jQuery.json2xml(arrCSS, options);

    };

    //retrieve map pin list CSS elements for saving to the database
    retrieveListCSS = function() {

        var arrCSS = [];

        jQuery('[id ^= styleList]').each(function() {
            var item = replaceAll(jQuery(this).attr('item'), "_", "-");
            arrCSS[item] = jQuery(this).attr('value');
        });

        var options = {
            formatOutput: true,
            rootTagName: 'settings'
        };
        return jQuery.json2xml(arrCSS, options);

    };

    //retrieve map's CSS elements for saving to the database
    retrieveMapCSS = function() {

        var arrCSS = [];

        jQuery('[id ^= styleElement]').each(function() {
            var item = replaceAll(jQuery(this).attr('item'), "_", "-");
            arrCSS[item] = jQuery(this).attr('value');
        });

        var options = {
            formatOutput: true,
            rootTagName: 'settings'
        };
        return jQuery.json2xml(arrCSS, options);

    };

    //retrieve the map settings for rendering/saving the map
    retrieveMapOptions = function($lat, $lng, $zoom) {

        var $mapType = jQuery('#mapType').val().toUpperCase();
        if ($mapType === "ROADMAP")
            $mapType = google.maps.MapTypeId.ROADMAP;
        else if ($mapType === "HYBRID")
            $mapType = google.maps.MapTypeId.HYBRID;
        else if ($mapType === "SATELLITE")
            $mapType = google.maps.MapTypeId.SATELLITE;
        else if ($mapType === "TERRAIN")
            $mapType = google.maps.MapTypeId.TERRAIN;
        else
            $mapType = google.maps.MapTypeId.ROADMAP;

        var $mapTypeControl_style = google.maps.MapTypeControlStyle.DEFAULT;
        var $mapTypeControl_position = google.maps.ControlPosition.TOP_LEFT;
        var $latlng = new google.maps.LatLng($lat, $lng);

        //theme
        var $mapTheme = parseInt(jQuery('#MapThemeName').val());

        var $styles = [];
        for (var t = 0; t < $arrThemes.length; t++) {

            if($mapTheme == parseInt($arrThemes[t].ID)){
                if ($arrThemes[t].Styles != null && $arrThemes[t].Styles.length > 0){
                    $styles = jQuery.parseJSON($arrThemes[t].Styles);
                    break;
                }
            }
        }

        var mapOptions = {
            zoom: $zoom,
            center: $latlng,
            styles: $styles,
            mapTypeId: $mapType,
            mapTypeControl: false,
            clusterpins: false,
            trafficlayer: false,
            transitlayer: false,
            bicyclelayer: false,
            polyline_strokecolor: '000000',
            polyline_opacity: '1.0',
            polyline_strokeweight: '1',
            mapTypeControlOptions: {
                style: $mapTypeControl_style,
                position: $mapTypeControl_position
            },
            zoomControl: true,
            navigationControl: true,
            zoomControlOptions: {
                style: google.maps.ZoomControlStyle.SMALL,
                position: google.maps.ControlPosition.LEFT_TOP
            },
            scaleControl: false,
            scaleControlOptions: {
                position: google.maps.ControlPosition.TOP_LEFT
            },
            streetViewControl: true,
            panControl: false,
            draggable: true
        };

        return mapOptions;

    };

    //retrieve all map templates from the database
    retrieveMapTemplates = function(mapID, templateID) {

        try{

            jQuery.ajax({
                type: 'POST',
                url: ajaxurl,
                dataType: 'json',
                data: {
                    mapID: mapID,
                    action: "retrieve_map_templates"
                },
                success: function(arrTemplates) {

                    $arrTemplates = arrTemplates;

                    for (var t = 0; t < arrTemplates.length; t++) {
                        jQuery("#MapTemplateName").append("<option value='" + arrTemplates[t].ID + "'>" + arrTemplates[t].TemplateName + "</option>");
                    }

                    if (parseInt(templateID) === 0) {
                        //this is a new map - set it to the first template in the list
                        jQuery("#MapTemplateName").val(arrTemplates[0].ID);
                    } else {
                        jQuery("#MapTemplateName").val(templateID);
                    }

                    easy2map_map_functions.changeMapTemplate();
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });

        } catch (e) {
            alert('Error in retrieveMapTemplates - ' + e.message + '. If error persists, please contact plugin author.');
        }

};

    //retrieve all map themes from the database
    retrieveMapThemes = function(mapID, themeID, templateID) {

        try{

            jQuery.ajax({
                type: 'POST',
                url: ajaxurl,
                dataType: 'json',
                data: {
                    mapID: mapID,
                    action: "retrieve_map_themes"
                },
                success: function(arrThemes) {

                    $arrThemes = arrThemes;

                    for (var t = 0; t < arrThemes.length; t++) {
                        jQuery("#MapThemeName").append("<option value='" + arrThemes[t].ID + "'>" + arrThemes[t].ThemeName + "</option>");
                    }

                    if (themeID == null || parseInt(themeID) === 0) {
                        //this is a new map - set it to the first template in the list
                        jQuery("#MapThemeName").val(arrThemes[0].ID);
                    } else {
                        jQuery("#MapThemeName").val(themeID);
                    }

                    retrieveMapTemplates(mapID, templateID);
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });

        } catch (e) {
            alert('Error in retrieveMapThemes - ' + e.message + '. If error persists, please contact plugin author.');
        }

};

return {
        //Change a single CSS value
        changeElementValue: function(i, element, proVersion) {

            if (proVersion === false)
                return;

            var attribute, value, type = "px";

            if (element === 1) {
                attribute = jQuery('#styleElement' + i).attr('item');
                value = jQuery('#styleElement' + i).attr('value');
                if (value.indexOf("px") !== -1) {
                    type = "px";
                } else if (value.indexOf("em") !== -1) {
                    type = "em";
                }
                value = replaceAll(replaceAll(replaceAll(value, "em", ""), "px", ""), "#", "");
            } else if (element === 2) {
                attribute = jQuery('#styleList' + i).attr('item');
                value = jQuery('#styleList' + i).attr('value');
                if (value.indexOf("px") !== -1) {
                    type = "px";
                } else if (value.indexOf("em") !== -1) {
                    type = "em";
                }
                value = replaceAll(replaceAll(replaceAll(value, "em", ""), "px", ""), "#", "");
            } else if (element === 3) {
                attribute = jQuery('#styleHeading' + i).attr('item');
                value = jQuery('#styleHeading' + i).attr('value');
                if (value.indexOf("px") !== -1) {
                    type = "px";
                } else if (value.indexOf("em") !== -1) {
                    type = "em";
                }
                value = replaceAll(replaceAll(replaceAll(value, "em", ""), "px", ""), "#", "");
            }

            $styleElementIndex = i;
            $styleSelectedElement = element;
            jQuery('div[id ^= div_edit_]').hide();

            switch (attribute) {

                case "border_style":
                {
                    jQuery('#tdheading_style').html("Border Style");
                    jQuery('#div_edit_style').modal();
                    jQuery('#txtDefaultValue_style').val(value).focus();
                    break;
                }

                case "font_family":
                {
                    jQuery('#tdheading_fontfamily').html("Font Family");
                    jQuery('#div_edit_fontfamily').modal();
                    jQuery('#txtDefaultValue_fontfamily').val(value).focus();
                    break;
                }

                case "border_width":
                {

                    jQuery('#tdheading_pixel').html("Border Width");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(0); i <= parseInt(50); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val(type).prop('disabled', false);
                        break;
                    }

                    case "font_size":
                    {
                        jQuery('#tdheading_pixel').html("Font Size");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(5); i <= parseInt(25); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val(type).prop('disabled', false);
                        break;
                    }

                    case "padding":
                    {
                        jQuery('#tdheading_pixel').html("Padding");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(10); i <= parseInt(2000); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val(type).prop('disabled', false);
                        break;
                    }

                    case "text_align":
                    {
                        jQuery('#tdheading_textalign').html("Text Align");
                        jQuery('#div_edit_textalign').modal();
                        jQuery('#txtDefaultValue_textalign').val(value).focus();
                        break;
                    }

                    case "width":
                    {

                        if (value.indexOf("%") !== -1) {

                            //percentage-based width
                            jQuery('#tdheading_percentage').html("Width");
                            jQuery('#txtDefaultValue_percentage').find('option').remove();
                            for (var i = parseInt(1); i <= parseInt(110); i++)
                                jQuery('#txtDefaultValue_percentage').append('<option value="' + i + '">' + i + '</option>');
                            jQuery('#div_edit_percentage').modal();
                            jQuery('#txtDefaultValue_percentage').val(replaceAll(value, "%", "")).focus();

                        } else {

                            //pixel-based width
                            jQuery('#tdheading_pixel').html("Width");
                            jQuery('#div_edit_pixel').modal();
                            jQuery('#txtDefaultValue_pixel').val(value).focus();
                            jQuery('#txtDefaultValue_pixel_em').val('px').prop('disabled', 'disabled');
                        }


                        break;
                    }

                    case "height":
                    {

                        jQuery('#tdheading_pixel').html("Height");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(10); i <= parseInt(2000); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val('px').prop('disabled', 'disabled');
                        break;
                    }

                    case "max_height":
                    {

                        jQuery('#tdheading_pixel').html("Maximum Height");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(10); i <= parseInt(2000); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val('px').prop('disabled', 'disabled');
                        break;
                    }

                    case "min_height":
                    {

                        jQuery('#tdheading_pixel').html("Minimum Height");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(10); i <= parseInt(2000); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val('px').prop('disabled', 'disabled');
                        break;
                    }

                    case "max_width":
                    {

                        jQuery('#tdheading_pixel').html("Maximum Width");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(10); i <= parseInt(2000); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val('px').prop('disabled', 'disabled');
                        break;
                    }

                    case "min_width":
                    {

                        jQuery('#tdheading_pixel').html("Minimum Width");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(10); i <= parseInt(2000); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val('px').prop('disabled', 'disabled');
                        break;
                    }

                    case "margin_bottom":
                    {

                        jQuery('#tdheading_margin').html("Bottom Margin");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "margin_top":
                    {

                        jQuery('#tdheading_margin').html("Top Margin");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "margin_left":
                    {

                        jQuery('#tdheading_margin').html("Left Margin");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "margin_right":
                    {

                        jQuery('#tdheading_margin').html("Right Margin");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }




                    case "padding_bottom":
                    {

                        jQuery('#tdheading_margin').html("Bottom Padding");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "padding_top":
                    {

                        jQuery('#tdheading_margin').html("Top Padding");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "padding_left":
                    {

                        jQuery('#tdheading_margin').html("Left Padding");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "padding_right":
                    {

                        jQuery('#tdheading_margin').html("Right Padding");
                        jQuery('#txtDefaultValue_margin').find('option').remove();
                        jQuery('#txtDefaultValue_margin').append('<option value="auto">auto</option>');
                        for (var i = parseInt(0); i <= parseInt(500); i++)
                            jQuery('#txtDefaultValue_margin').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_margin').modal();
                        jQuery('#txtDefaultValue_margin').val(value).focus();
                        break;
                    }

                    case "border_radius":
                    {

                        jQuery('#tdheading_pixel').html("Border Radius");
                        //jQuery('#txtDefaultValue_pixel').find('option').remove();
                        //for (var i = parseInt(0); i <= parseInt(500); i++)
                        //    jQuery('#txtDefaultValue_pixel').append('<option value="' + i + '">' + i + '</option>');
                        jQuery('#div_edit_pixel').modal();
                        jQuery('#txtDefaultValue_pixel').val(value).focus();
                        jQuery('#txtDefaultValue_pixel_em').val(type).prop('disabled', false);
                        break;
                    }

                    case "border_color":
                    {
                        jQuery('#tdheading_color').html("Border Color");
                        jQuery('#div_edit_color').modal();
                        jQuery('#txtDefaultValue_color').css('background-color', '#' + value).val(value).focus();
                        jQuery('#txtDefaultValue_color2').val(value);
                        var myPicker = new jscolor.color(document.getElementById('txtDefaultValue_color'), {});
                        myPicker.fromString(document.getElementById("txtDefaultValue_color").value);
                        break;
                    }

                    case "background_color":
                    {
                        jQuery('#tdheading_color').html("Background Color");
                        jQuery('#div_edit_color').modal();
                        jQuery('#txtDefaultValue_color').css('background-color', '#' + value).val(value).focus();
                        jQuery('#txtDefaultValue_color2').val(value);
                        var myPicker = new jscolor.color(document.getElementById('txtDefaultValue_color'), {});
                        myPicker.fromString(document.getElementById("txtDefaultValue_color").value);
                        break;
                    }

                    case "color":
                    {
                        jQuery('#tdheading_color').html("Color");
                        jQuery('#div_edit_color').modal();
                        jQuery('#txtDefaultValue_color').css('color', '#' + value).val(value).focus();
                        jQuery('#txtDefaultValue_color2').val(value);
                        var myPicker = new jscolor.color(document.getElementById('txtDefaultValue_color'), {});
                        myPicker.fromString(document.getElementById("txtDefaultValue_color").value);
                        break;
                    }

                }

            },
        //change a map's template
        changeMapTemplate: function() {

            var templateID = jQuery("#MapTemplateName").val();
            jQuery('#divPreview').html('');
            var proVersion = !!jQuery("#mapType").attr("proVersion");

            for (var t = 0; t < $arrTemplates.length; t++) {

                var template = $arrTemplates[t];
                if (parseInt(template.ID) == templateID) {

                    jQuery('#MapTemplateExampleImg').attr("src", $pluginsURL + template.ExampleImage);

                    var css = jQuery.xml2json(template.CSSValues);
                    var css2 = jQuery.xml2json(template.CSSValuesList);
                    var css3 = jQuery.xml2json(template.CSSValuesHeading);
                    jQuery('#MapTemplateCSS').html('');
                    jQuery('#MapTemplateListCSS').html('');
                    jQuery('#MapTemplateHeadingCSS').html('');

                    var j = 0;
                    var width = "", height = "";
                    for (var item in css) {

                        if (item === "width") {
                            width = css[item];
                        }
                        if (item === "height") {
                            height = css[item];
                        }

                        jQuery('#MapTemplateCSS').append('<div class="cssStyleEditorParent"><a id="styleElement' + j + '" class="cssEdit" href="javascript:easy2map_map_functions.changeElementValue(' + j + ', 1, ' + proVersion + ');" item="' + item + '" value="' + css[item] + '">' + normaliseCSSElement(item) + " (" + css[item] + ")</a></div>");
                        j += 1;
                    }

                    j = 0;
                    for (var item in css2) {
                        jQuery('#MapTemplateListCSS').append('<div class="cssStyleEditorParent"><a id="styleList' + j + '" class="cssEdit" href="javascript:easy2map_map_functions.changeElementValue(' + j + ', 2, ' + proVersion + ');" item="' + item + '" value="' + css2[item] + '">' + normaliseCSSElement(item) + " (" + css2[item] + ")</a></div>");
                        j += 1;
                    }

                    j = 0;
                    for (var item in css3) {
                        jQuery('#MapTemplateHeadingCSS').append('<div class="cssStyleEditorParent"><a id="styleHeading' + j + '" class="cssEdit" href="javascript:easy2map_map_functions.changeElementValue(' + j + ', 3, ' + proVersion + ');" item="' + item + '" value="' + css3[item] + '">' + normaliseCSSElement(item) + " (" + css3[item] + ")</a></div>");
                        j += 1;
                    }

                    jQuery("#mapSize").html("");
                    jQuery("#mapSize").append("<option value='640px,480px'>640px x 480px</option>");
                    jQuery("#mapSize").append("<option value='425px,350px'>425px x 350px</option>");
                    jQuery("#mapSize").append("<option value='300px,300px'>300px x 300px</option>");
                    jQuery("#mapSize").append("<option value='custom'>Set Custom Size</option>");

                    jQuery("#mapSize").val(width + "," + height).attr("selected", "selected");

                    if (jQuery("#mapSize option:selected").val() != width + "," + height) {
                        jQuery("#mapSize option:eq(" + parseInt(jQuery("#mapSize option").length - 2) + ")").after("<option selected='selected' value='" + width + "," + height + "'>" + width + " x " + height + "</option>");
                    }

                }
            }
            refreshExampleMap(true);
        },


        //change a map's theme
        changeMapTheme: function() {
            refreshExampleMap(true);
        },

        changeMapType: function() {

            var $mapType = jQuery('#mapType').val().toUpperCase();
            if ($mapType === "ROADMAP")
                $mapType = google.maps.MapTypeId.ROADMAP;
            else if ($mapType === "HYBRID")
                $mapType = google.maps.MapTypeId.HYBRID;
            else if ($mapType === "SATELLITE")
                $mapType = google.maps.MapTypeId.SATELLITE;
            else if ($mapType === "TERRAIN")
                $mapType = google.maps.MapTypeId.TERRAIN;
            else
                $mapType = google.maps.MapTypeId.ROADMAP;

            $map.setMapTypeId($mapType);

        },
        changeMarkerPopups: function() {
            refreshExampleMap(true);
        },
        cloneExistingMap: function(mapID) {

            this.retrieveMapSettings(mapID, true);
            jQuery('#MapClone').hide();

        },
        //allow the user to set a custom size for their map
        setCustomMapSize: function() {

            if (isNaN(document.getElementById('txtCustomWidthValue').value))
                return;
            if (isNaN(document.getElementById('txtCustomHeightValue').value))
                return;

            if (parseInt(document.getElementById('txtCustomWidthValue').value) < 0)
                return;
            if (parseInt(document.getElementById('txtCustomHeightValue').value) < 0)
                return;

            var width = jQuery('#txtCustomWidthValue').val() + jQuery('#mapWidthDimension').val();
            var height = jQuery('#txtCustomHeightValue').val() + 'px';
            easy2map_map_functions.changeMapSize(width + ',' + height);
        },
        //save the map's new size 
        changeMapSize: function(size) {

            if (size === "custom") {
                jQuery('[id ^= styleElement]').each(function() {

                    if (jQuery(this).attr('item') === 'width') {

                        var currentWidth = jQuery(this).attr('value');
                        if (currentWidth.indexOf('px') > 0) {
                            jQuery('#mapWidthDimension').val('px');
                        } else {
                            jQuery('#mapWidthDimension').val('%');
                        }

                        jQuery('#txtCustomWidthValue').val(parseInt(currentWidth));

                    }
                    if (jQuery(this).attr('item') === 'height') {
                        jQuery('#txtCustomHeightValue').val(parseInt(jQuery(this).attr('value')));
                    }
                });
                jQuery('#div_edit_widthheight').modal();
                return;
            }
            var arrSize = size.split(',');
            if (arrSize.length < 2)
                return;

            jQuery('[id ^= styleElement]').each(function() {

                if (jQuery(this).attr('item') === 'width') {
                    jQuery(this).attr('value', arrSize[0]);
                    jQuery(this).html('Width' + ' (' + arrSize[0] + ')');
                }
                if (jQuery(this).attr('item') === 'height') {
                    jQuery(this).attr('value', arrSize[1]);
                    jQuery(this).html('Height' + ' (' + arrSize[1] + ')');
                }

            });

            jQuery("#mapSize").val(arrSize[0] + "," + arrSize[1]).attr("selected", "selected");

            if (jQuery("#mapSize option:selected").val() != arrSize[0] + "," + arrSize[1]) {
                jQuery("#mapSize option:eq(" + parseInt(jQuery("#mapSize option").length - 2) + ")").after("<option selected='selected' value='" + arrSize[0] + "," + arrSize[1] + "'>" + arrSize[0] + " x " + arrSize[1] + "</option>");
            }

            refreshExampleMap(true);

        },
        //retrieve map's settings from the database
        retrieveMapSettings: function(mapID, ignoreMapName) {

            try{

                jQuery.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    dataType: 'json',
                    data: {
                        mapID: mapID,
                        action: "retrieve_map_settings"
                    },
                    success: function(mapSettings) {

                        $mapSettings = mapSettings;
                        var settings = jQuery.xml2json($mapSettings.Settings);
                        jQuery('#draggable').attr("src", $mapSettings.DefaultPinImage);

                        if (!!ignoreMapName === false) {
                            if ($mapSettings.MapName) {
                                jQuery('#mapName').val($mapSettings.MapName);
                                jQuery('#mapName2').html($mapSettings.MapName);
                            } else {
                                jQuery('#mapName2').html("Untitled Map");
                            }
                        }

                        jQuery('#mapType').val(settings.mapType.toUpperCase());
                        jQuery('#markerNameInPopups').prop("checked", parseInt(settings.showMarkerTitle) === 1 ? true : false);
                        jQuery('#markerNameFontSize').val(parseInt(settings.markerNameFontSize) > 0 ? settings.markerNameFontSize + '' : 1 + '');

                        jQuery('#setMaxWidthPopups').prop("checked", parseInt(settings.setMaxWidthPopups) === 1 ? true : false);
                        jQuery('#maxWidthPopups').val(parseInt(settings.maxWidthPopups) > 0 ? settings.maxWidthPopups : 250);

                        jQuery('#directionsInPopups').prop("checked", parseInt(settings.showDirections) === 1 ? true : false);
                        jQuery('#directionsLinkTitle').val(!!settings.directionsLinkTitle ? settings.directionsLinkTitle : "Get Directions");
                        jQuery('#directionsLinkFontSize').val(parseInt(settings.directionsLinkFontSize) > 0 ? settings.directionsLinkFontSize : 1);
                        
                        if (typeof settings.descriptionInListItems == "undefined"){
                            jQuery('#descriptionInListItems').prop("checked", true);
                        } else {
                            jQuery('#descriptionInListItems').prop("checked", parseInt(settings.descriptionInListItems) === 1 ? true : false);
                        }

                        if (typeof settings.allowMapZoom == "undefined"){
                            jQuery('#allowMapZoom').prop("checked", true);
                        } else {
                            jQuery('#allowMapZoom').prop("checked", parseInt(settings.allowMapZoom) === 1 ? true : false);
                        }

                        if (typeof settings.centerOnUsersLocation == "undefined"){
                            jQuery('#centerOnUsersLocation').prop("checked", false);
                        } else {
                            jQuery('#centerOnUsersLocation').prop("checked", parseInt(settings.centerOnUsersLocation) === 1 ? true : false);
                        }

                        if (typeof settings.orderListByDistance == "undefined"){
                            jQuery('#orderListByDistance').prop("checked", false);
                        } else {
                            jQuery('#orderListByDistance').prop("checked", parseInt(settings.orderListByDistance) === 1 ? true : false);
                        }

                        if (typeof settings.pinListShowSearch == "undefined"){
                            jQuery('#pinListShowSearch').prop("checked", false);
                        } else {
                            jQuery('#pinListShowSearch').prop("checked", parseInt(settings.pinListShowSearch) === 1 ? true : false);
                        }

                        jQuery('#pinListShowSearchPlaceHolder').val(!!settings.pinListShowSearchPlaceHolder ? settings.pinListShowSearchPlaceHolder : "Search");
                        
                        if (typeof settings.pinListDisplayOrder == "undefined"){
                            jQuery('input[name=displayorder][value="alpha"]').prop('checked', 'checked'); 

                        } else {
                            jQuery('input[name=displayorder][value="' + settings.pinListDisplayOrder + '"]').prop('checked', 'checked'); 
                        }

                        jQuery('#mapEditPencil').show();
                        if ($mapSettings.ThemeID == null) $mapSettings.ThemeID = 1;
                        retrieveMapThemes(mapID, $mapSettings.ThemeID, $mapSettings.TemplateID);

                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                        alert('could not retrieve map settings');
                    }
                });

            } catch (e) {
                alert('Error in retrieveMapSettings - ' + e.message + '. If error persists, please contact plugin author.');
            }
        
        },
        //save the CSS element that has been edited
        saveItemValue: function() {

            var attribute;

            if ($styleSelectedElement === 1)
                attribute = jQuery('#styleElement' + $styleElementIndex).attr('item');
            else if ($styleSelectedElement === 2)
                attribute = jQuery('#styleList' + $styleElementIndex).attr('item');
            else
                attribute = jQuery('#styleHeading' + $styleElementIndex).attr('item');

            var alteredValue = '';
            switch (attribute) {
                case "border_style":
                {
                    alteredValue = jQuery('#txtDefaultValue_style').val();
                    jQuery('#div_edit_style').hide();
                    break;
                }
                case "font_family":
                {
                    alteredValue = jQuery('#txtDefaultValue_fontfamily').val();
                    jQuery('#div_edit_fontfamily').hide();
                    break;
                }

                case "font_size":
                {
                    alteredValue = jQuery('#txtDefaultValue_pixel').val() + jQuery('#txtDefaultValue_pixel_em').val();
                    jQuery('#div_edit_em').hide();
                    break;

                }

                case "padding":
                {
                    alteredValue = jQuery('#txtDefaultValue_pixel').val() + jQuery('#txtDefaultValue_pixel_em').val();
                    jQuery('#div_edit_em').hide();
                    break;
                }

                case "text_align":
                {
                    alteredValue = jQuery('#txtDefaultValue_textalign').val();
                    jQuery('#div_edit_textalign').hide();
                    break;
                }

                case "border_width":
                {
                    alteredValue = jQuery('#txtDefaultValue_pixel').val() + jQuery('#txtDefaultValue_pixel_em').val();
                    jQuery('#div_edit_pixel').hide();
                    break;
                }
                case "width":
                {

                    if (jQuery('#styleElement' + $styleElementIndex).attr('value').indexOf("%") !== -1) {
                            //percentage-based width
                            alteredValue = jQuery('#txtDefaultValue_percentage').val() + "%";
                            jQuery('#div_edit_percentage').hide();
                        }
                        else {
                            //pixel based width
                            alteredValue = jQuery('#txtDefaultValue_pixel').val() + "px";
                            jQuery('#div_edit_pixel').hide();

                        }
                        break;
                    }
                    case "height":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val() + "px";
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                    case "min_height":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val() + "px";
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                    case "max_width":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val() + "px";
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                    case "min_width":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val() + "px";
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                    case "max_height":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val() + "px";
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                    case "margin_top":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }
                    case "margin_bottom":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }
                    case "margin_left":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }
                    case "margin_right":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }

                    case "padding_top":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }
                    case "padding_bottom":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }
                    case "padding_left":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }
                    case "padding_right":
                    {
                        alteredValue = jQuery('#txtDefaultValue_margin').val();
                        if (alteredValue != "auto")
                            alteredValue += "px";
                        jQuery('#div_edit_margin').hide();
                        break;
                    }

                    case "border_color":
                    {
                        alteredValue = '#' + jQuery('#txtDefaultValue_color').val();
                        jQuery('#tdItemElementValue').css('background-Color', '#' + jQuery('#txtDefaultValue_color').val());
                        jQuery('#div_edit_color').hide();
                        break;
                    }
                    case "background_color":
                    {
                        alteredValue = '#' + jQuery('#txtDefaultValue_color').val();
                        jQuery('#tdItemElementValue').css('background-Color', '#' + jQuery('#txtDefaultValue_color').val());
                        jQuery('#div_edit_color').hide();
                        break;
                    }
                    case "color":
                    {
                        alteredValue = '#' + jQuery('#txtDefaultValue_color').val();
                        jQuery('#tdItemElementValue').css('color', '#' + jQuery('#txtDefaultValue_color').val());
                        jQuery('#div_edit_color').hide();
                        break;
                    }
                    case "z-index":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val();
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                    case "border_radius":
                    {
                        alteredValue = jQuery('#txtDefaultValue_pixel').val() + jQuery('#txtDefaultValue_pixel_em').val();
                        jQuery('#div_edit_pixel').hide();
                        break;
                    }
                }

                if ($styleSelectedElement === 1) {
                    jQuery('#styleElement' + $styleElementIndex).attr('value', alteredValue);
                    jQuery('#styleElement' + $styleElementIndex).html(normaliseCSSElement(attribute) + ' (' + alteredValue + ')');

                }
                else if ($styleSelectedElement === 2) {
                    jQuery('#styleList' + $styleElementIndex).attr('value', alteredValue);
                    jQuery('#styleList' + $styleElementIndex).html(normaliseCSSElement(attribute) + ' (' + alteredValue + ')');

                }
                else {
                    jQuery('#styleHeading' + $styleElementIndex).attr('value', alteredValue);
                    jQuery('#styleHeading' + $styleElementIndex).html(normaliseCSSElement(attribute) + ' (' + alteredValue + ')');

                }

                refreshExampleMap(true);
            },
        //save the map to the database
        saveMap: function(redirect, showMapID) {

            try{

                var settings = jQuery.xml2json($mapSettings.Settings);
                var $lat = settings.lattitude;
                var $lng = settings.longitude;
                var $zoom = parseInt(settings.zoom);

                var $showMarkerTitle = jQuery('#markerNameInPopups').prop("checked") ? "1" : "0";
                var $markerNameFontSize = jQuery('#markerNameFontSize').val();
                var $setMaxWidthPopups = jQuery('#setMaxWidthPopups').prop("checked") ? "1" : "0";
                var $maxWidthPopups = jQuery('#maxWidthPopups').val();

                var $showDirections = jQuery('#directionsInPopups').prop("checked") ? "1" : "0";
                var $directionsLinkTitle = encodeURIComponent(jQuery('#directionsLinkTitle').val());
                var $directionsLinkFontSize = jQuery('#directionsLinkFontSize').val();

                var $descriptionInListItems = jQuery('#descriptionInListItems').prop("checked") ? "1" : "0";
                var $allowMapZoom = jQuery('#allowMapZoom').prop("checked") ? "1" : "0";
                var $centerOnUsersLocation = jQuery('#centerOnUsersLocation').prop("checked") ? "1" : "0";
                var $orderListByDistance = jQuery('#orderListByDistance').prop("checked") ? "1" : "0";
                var $pinListShowSearch = jQuery('#pinListShowSearch').prop("checked") ? "1" : "0";
                var $pinListShowSearchPlaceHolder = encodeURIComponent(jQuery('#pinListShowSearchPlaceHolder').val());
                var $pinListDisplayOrder = jQuery('input[name=displayorder]:checked', '#display_order_form').val();
                if (!$pinListDisplayOrder) $pinListDisplayOrder = 'alpha';

                jQuery("[id ^= 'e2mPin']").each(function(){
                    jQuery(this).html('');
                })

                if ($map != null) {
                    $lat = $map.getCenter().lat();
                    $lng = $map.getCenter().lng();
                    $zoom = $map.getZoom();
                }

                var $mapType = jQuery('#mapType').val().toUpperCase();
                if ($mapType === "ROADMAP")
                    $mapType = google.maps.MapTypeId.ROADMAP;
                else if ($mapType === "HYBRID")
                    $mapType = google.maps.MapTypeId.HYBRID;
                else if ($mapType === "SATELLITE")
                    $mapType = google.maps.MapTypeId.SATELLITE;
                else if ($mapType === "TERRAIN")
                    $mapType = google.maps.MapTypeId.TERRAIN;
                else
                    $mapType = google.maps.MapTypeId.ROADMAP;

                //theme
                var $mapTheme = parseInt(jQuery('#MapThemeName').val());
                var $styles = [];
                for (var t = 0; t < $arrThemes.length; t++) {

                    if($mapTheme == parseInt($arrThemes[t].ID)){
                        if ($arrThemes[t].Styles != null && $arrThemes[t].Styles.length > 0){
                            $styles = jQuery.parseJSON($arrThemes[t].Styles);
                            break;
                        }
                    }

                }

                var mapOptions = {
                    lattitude: $lat,
                    longitude: $lng,
                    styles: $styles,
                    zoom: $zoom,
                    mapType: $mapType,
                    backgroundColor: 'FFFFFF',
                    draggable: 1,
                    clusterpins: 0,
                    trafficlayer: 0,
                    transitlayer: 0,
                    bicyclelayer: 0,
                    scrollWheel: 0,
                    mapTypeControl: 0,
                    panControl: 0,
                    rotateControl: 0,
                    scaleControl: 0,
                    streetViewControl: 1,
                    zoomControl: 1,
                    mapTypeControl_style: 'DROPDOWN_MENU',
                    mapTypeControl_position: 'TOP_RIGHT',
                    panControl_position: 'TOP_LEFT',
                    rotateControl_position: 'TOP_LEFT',
                    scaleControl_position: 'TOP_LEFT',
                    streetViewControl_position: 'TOP_LEFT',
                    zoomControl_position: 'TOP_LEFT',
                    zoomControl_style: 'SMALL',
                    polyline_strokecolor: '000000',
                    polyline_opacity: '1.0',
                    polyline_strokeweight: '1',
                    showMarkerTitle: $showMarkerTitle,
                    markerNameFontSize: $markerNameFontSize,
                    setMaxWidthPopups: $setMaxWidthPopups,
                    maxWidthPopups: $maxWidthPopups,
                    showDirections: $showDirections,
                    directionsLinkTitle: $directionsLinkTitle,
                    directionsLinkFontSize: $directionsLinkFontSize,
                    descriptionInListItems : $descriptionInListItems,
                    allowMapZoom : $allowMapZoom,
                    centerOnUsersLocation : $centerOnUsersLocation,
                    orderListByDistance : $orderListByDistance,
                    pinListShowSearch : $pinListShowSearch,
                    pinListShowSearchPlaceHolder : $pinListShowSearchPlaceHolder,
                    pinListDisplayOrder : $pinListDisplayOrder

                };
                var options = {
                    formatOutput: true,
                    rootTagName: 'settings'
                };

                jQuery('#divMap').html('');
                var HTMLToSave = jQuery('#divPreview').html();

                jQuery.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    dataType: 'json',
                    data: {
                        mapID: $mapID,
                        mapName: jQuery('#mapName').val() == "" ? "Untitled Map" : jQuery('#mapName').val(),
                        mapTemplateName: jQuery('#MapTemplateName').val(),
                        action: "save_map",
                        mapSettingsXML: jQuery.json2xml(mapOptions, options),
                        mapCSSXML: encodeURIComponent(retrieveMapCSS()),
                        listCSSXML: encodeURIComponent(retrieveListCSS()),
                        headingCSSXML: encodeURIComponent(retrieveHeadingCSS()),
                        mapHTML: encodeURIComponent(HTMLToSave),
                        mapThemeName: jQuery('#MapThemeName').val()
                    },
                    success: function(mapID) {
                        if (redirect) {

                            if (showMapID) {

                                jQuery('#txtShortCode').val('[easy2map id=' + mapID + ']');
                                jQuery('#mapShortCode').modal({
                                    keyboard: false
                                });

                                jQuery('#mapShortCode').on('shown', function() {
                                    document.getElementById('txtShortCode').focus();
                                    document.getElementById('txtShortCode').select();
                                });

                            } else {

                                window.location = '?page=easy2map&action=viewmaps';

                            }

                            return;
                        }
                        $mapID = mapID;
                        //set the action of the pin upload form to reflect the new mapID!
                        jQuery('#formAddPinIcon').attr('action', '?page=easy2map&action=mappinimagesave&map_id=' + $mapID);

                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });

            } catch (e) {
                alert('Error in saveMap - ' + e.message + '. If error persists, please contact plugin author.');
            }
},
        //save the map to the database
        saveMapName: function() {

            try{

                jQuery.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    dataType: 'json',
                    data: {
                        mapID: $mapID,
                        mapName: jQuery('#mapName').val() == "" ? "Untitled Map" : jQuery('#mapName').val(),
                        action: "save_map_name"
                    },
                    success: function() {
                        jQuery("#divMapHeading").html(jQuery('#mapName').val() === "" ? "Untitled Map" : jQuery('#mapName').val());
                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
                
            } catch (e) {
                alert('Error in saveMapName - ' + e.message + '. If error persists, please contact plugin author.');
            }
        },
        //verify that the import file is a valid XML document
        uploadImportFile: function() {

            if (document.getElementById('xmlfile').value === "")
                return;
            var bContinue = true;

            var validateFileType = checkFileExtensionSilent(document.getElementById('xmlfile'));
            if (validateFileType != '') {
                alert('Invalid XML file.');
                bContinue = false;
                return;
            }

            if (bContinue == true) {
                busy();
                document.formImport.submit();
            }
        },
        importFileViaCSV: function() {

            if (parseInt($mapID) === 0) {

                jQuery.when(easy2map_map_functions.saveMap(false, false)).then(
                    function(data, textStatus, jqXHR) {
                        window.location = '?page=easy2map&action=mapimportcsv&map_id=' + $mapID;
                    });
            } else {
                window.location = '?page=easy2map&action=mapimportcsv&map_id=' + $mapID;
            }

        },
        importFileViaCSV2: function() {

            if (parseInt($mapID) === 0) {

                jQuery.when(easy2map_map_functions.saveMap(false, false)).then(
                    function(data, textStatus, jqXHR) {
                        window.location = '?page=easy2map&action=mapimportcsv2&map_id=' + $mapID;
                    });
            } else {
                window.location = '?page=easy2map&action=mapimportcsv2&map_id=' + $mapID;
            }

        },
        //verify that the import file is a valid XML document
        uploadImportCSV: function() {

            if (document.getElementById('csvfile').value === "")
                return;
            var csvContinue = true;

            var validateFileType = checkFileExtensionSilent(document.getElementById('csvfile'));
            if (validateFileType !== '') {
                alert('Invalid CSV file.');
                csvContinue = false;
                return;
            }

            if (csvContinue === true) {
                document.formImport3.submit();
            }
        },

        getUserLocation : function (returnData, centerOnLocation) {

            try{

                var zoom = $map.getZoom();

                navigator.geolocation.getCurrentPosition(
                function(position){

                    var userLocation = new google.maps.LatLng(
                        position.coords.latitude, 
                        position.coords.longitude);

                    if (!!centerOnLocation){
                        $map.setCenter(userLocation);
                        $map.setZoom(zoom);
                    }

                    easy2map_mappin_functions.setupPinsAndList(returnData, userLocation, true);

                }, function(error){

                    easy2map_mappin_functions.setupPinsAndList(returnData, $map.getCenter(), false);
                });

            } catch(e){

                easy2map_mappin_functions.setupPinsAndList(returnData, $map.getCenter(), false);
                
            }    

        }

    };


})();



/**
 * lunr - http://lunrjs.com - A bit like Solr, but much smaller and not as bright - 0.7.0
 * Copyright (C) 2016 Oliver Nightingale
 * MIT Licensed
 * @license
 */
!function(){var t=function(e){var n=new t.Index;return n.pipeline.add(t.trimmer,t.stopWordFilter,t.stemmer),e&&e.call(n,n),n};t.version="0.7.0",t.utils={},t.utils.warn=function(t){return function(e){t.console&&console.warn&&console.warn(e)}}(this),t.utils.asString=function(t){return void 0===t||null===t?"":t.toString()},t.EventEmitter=function(){this.events={}},t.EventEmitter.prototype.addListener=function(){var t=Array.prototype.slice.call(arguments),e=t.pop(),n=t;if("function"!=typeof e)throw new TypeError("last argument must be a function");n.forEach(function(t){this.hasHandler(t)||(this.events[t]=[]),this.events[t].push(e)},this)},t.EventEmitter.prototype.removeListener=function(t,e){if(this.hasHandler(t)){var n=this.events[t].indexOf(e);this.events[t].splice(n,1),this.events[t].length||delete this.events[t]}},t.EventEmitter.prototype.emit=function(t){if(this.hasHandler(t)){var e=Array.prototype.slice.call(arguments,1);this.events[t].forEach(function(t){t.apply(void 0,e)})}},t.EventEmitter.prototype.hasHandler=function(t){return t in this.events},t.tokenizer=function(e){return arguments.length&&null!=e&&void 0!=e?Array.isArray(e)?e.map(function(e){return t.utils.asString(e).toLowerCase()}):e.toString().trim().toLowerCase().split(t.tokenizer.seperator):[]},t.tokenizer.seperator=/[\s\-]+/,t.tokenizer.load=function(t){var e=this.registeredFunctions[t];if(!e)throw new Error("Cannot load un-registered function: "+t);return e},t.tokenizer.label="default",t.tokenizer.registeredFunctions={"default":t.tokenizer},t.tokenizer.registerFunction=function(e,n){n in this.registeredFunctions&&t.utils.warn("Overwriting existing tokenizer: "+n),e.label=n,this.registeredFunctions[n]=e},t.Pipeline=function(){this._stack=[]},t.Pipeline.registeredFunctions={},t.Pipeline.registerFunction=function(e,n){n in this.registeredFunctions&&t.utils.warn("Overwriting existing registered function: "+n),e.label=n,t.Pipeline.registeredFunctions[e.label]=e},t.Pipeline.warnIfFunctionNotRegistered=function(e){var n=e.label&&e.label in this.registeredFunctions;n||t.utils.warn("Function is not registered with pipeline. This may cause problems when serialising the index.\n",e)},t.Pipeline.load=function(e){var n=new t.Pipeline;return e.forEach(function(e){var i=t.Pipeline.registeredFunctions[e];if(!i)throw new Error("Cannot load un-registered function: "+e);n.add(i)}),n},t.Pipeline.prototype.add=function(){var e=Array.prototype.slice.call(arguments);e.forEach(function(e){t.Pipeline.warnIfFunctionNotRegistered(e),this._stack.push(e)},this)},t.Pipeline.prototype.after=function(e,n){t.Pipeline.warnIfFunctionNotRegistered(n);var i=this._stack.indexOf(e);if(-1==i)throw new Error("Cannot find existingFn");i+=1,this._stack.splice(i,0,n)},t.Pipeline.prototype.before=function(e,n){t.Pipeline.warnIfFunctionNotRegistered(n);var i=this._stack.indexOf(e);if(-1==i)throw new Error("Cannot find existingFn");this._stack.splice(i,0,n)},t.Pipeline.prototype.remove=function(t){var e=this._stack.indexOf(t);-1!=e&&this._stack.splice(e,1)},t.Pipeline.prototype.run=function(t){for(var e=[],n=t.length,i=this._stack.length,r=0;n>r;r++){for(var o=t[r],s=0;i>s&&(o=this._stack[s](o,r,t),void 0!==o&&""!==o);s++);void 0!==o&&""!==o&&e.push(o)}return e},t.Pipeline.prototype.reset=function(){this._stack=[]},t.Pipeline.prototype.toJSON=function(){return this._stack.map(function(e){return t.Pipeline.warnIfFunctionNotRegistered(e),e.label})},t.Vector=function(){this._magnitude=null,this.list=void 0,this.length=0},t.Vector.Node=function(t,e,n){this.idx=t,this.val=e,this.next=n},t.Vector.prototype.insert=function(e,n){this._magnitude=void 0;var i=this.list;if(!i)return this.list=new t.Vector.Node(e,n,i),this.length++;if(e<i.idx)return this.list=new t.Vector.Node(e,n,i),this.length++;for(var r=i,o=i.next;void 0!=o;){if(e<o.idx)return r.next=new t.Vector.Node(e,n,o),this.length++;r=o,o=o.next}return r.next=new t.Vector.Node(e,n,o),this.length++},t.Vector.prototype.magnitude=function(){if(this._magnitude)return this._magnitude;for(var t,e=this.list,n=0;e;)t=e.val,n+=t*t,e=e.next;return this._magnitude=Math.sqrt(n)},t.Vector.prototype.dot=function(t){for(var e=this.list,n=t.list,i=0;e&&n;)e.idx<n.idx?e=e.next:e.idx>n.idx?n=n.next:(i+=e.val*n.val,e=e.next,n=n.next);return i},t.Vector.prototype.similarity=function(t){return this.dot(t)/(this.magnitude()*t.magnitude())},t.SortedSet=function(){this.length=0,this.elements=[]},t.SortedSet.load=function(t){var e=new this;return e.elements=t,e.length=t.length,e},t.SortedSet.prototype.add=function(){var t,e;for(t=0;t<arguments.length;t++)e=arguments[t],~this.indexOf(e)||this.elements.splice(this.locationFor(e),0,e);this.length=this.elements.length},t.SortedSet.prototype.toArray=function(){return this.elements.slice()},t.SortedSet.prototype.map=function(t,e){return this.elements.map(t,e)},t.SortedSet.prototype.forEach=function(t,e){return this.elements.forEach(t,e)},t.SortedSet.prototype.indexOf=function(t){for(var e=0,n=this.elements.length,i=n-e,r=e+Math.floor(i/2),o=this.elements[r];i>1;){if(o===t)return r;t>o&&(e=r),o>t&&(n=r),i=n-e,r=e+Math.floor(i/2),o=this.elements[r]}return o===t?r:-1},t.SortedSet.prototype.locationFor=function(t){for(var e=0,n=this.elements.length,i=n-e,r=e+Math.floor(i/2),o=this.elements[r];i>1;)t>o&&(e=r),o>t&&(n=r),i=n-e,r=e+Math.floor(i/2),o=this.elements[r];return o>t?r:t>o?r+1:void 0},t.SortedSet.prototype.intersect=function(e){for(var n=new t.SortedSet,i=0,r=0,o=this.length,s=e.length,a=this.elements,h=e.elements;;){if(i>o-1||r>s-1)break;a[i]!==h[r]?a[i]<h[r]?i++:a[i]>h[r]&&r++:(n.add(a[i]),i++,r++)}return n},t.SortedSet.prototype.clone=function(){var e=new t.SortedSet;return e.elements=this.toArray(),e.length=e.elements.length,e},t.SortedSet.prototype.union=function(t){var e,n,i;this.length>=t.length?(e=this,n=t):(e=t,n=this),i=e.clone();for(var r=0,o=n.toArray();r<o.length;r++)i.add(o[r]);return i},t.SortedSet.prototype.toJSON=function(){return this.toArray()},t.Index=function(){this._fields=[],this._ref="id",this.pipeline=new t.Pipeline,this.documentStore=new t.Store,this.tokenStore=new t.TokenStore,this.corpusTokens=new t.SortedSet,this.eventEmitter=new t.EventEmitter,this.tokenizerFn=t.tokenizer,this._idfCache={},this.on("add","remove","update",function(){this._idfCache={}}.bind(this))},t.Index.prototype.on=function(){var t=Array.prototype.slice.call(arguments);return this.eventEmitter.addListener.apply(this.eventEmitter,t)},t.Index.prototype.off=function(t,e){return this.eventEmitter.removeListener(t,e)},t.Index.load=function(e){e.version!==t.version&&t.utils.warn("version mismatch: current "+t.version+" importing "+e.version);var n=new this;return n._fields=e.fields,n._ref=e.ref,n.tokenizer=t.tokenizer.load(e.tokenizer),n.documentStore=t.Store.load(e.documentStore),n.tokenStore=t.TokenStore.load(e.tokenStore),n.corpusTokens=t.SortedSet.load(e.corpusTokens),n.pipeline=t.Pipeline.load(e.pipeline),n},t.Index.prototype.field=function(t,e){var e=e||{},n={name:t,boost:e.boost||1};return this._fields.push(n),this},t.Index.prototype.ref=function(t){return this._ref=t,this},t.Index.prototype.tokenizer=function(e){var n=e.label&&e.label in t.tokenizer.registeredFunctions;return n||t.utils.warn("Function is not a registered tokenizer. This may cause problems when serialising the index"),this.tokenizerFn=e,this},t.Index.prototype.add=function(e,n){var i={},r=new t.SortedSet,o=e[this._ref],n=void 0===n?!0:n;this._fields.forEach(function(t){var n=this.pipeline.run(this.tokenizerFn(e[t.name]));i[t.name]=n;for(var o=0;o<n.length;o++){var s=n[o];r.add(s),this.corpusTokens.add(s)}},this),this.documentStore.set(o,r);for(var s=0;s<r.length;s++){for(var a=r.elements[s],h=0,u=0;u<this._fields.length;u++){var l=this._fields[u],c=i[l.name],f=c.length;if(f){for(var d=0,p=0;f>p;p++)c[p]===a&&d++;h+=d/f*l.boost}}this.tokenStore.add(a,{ref:o,tf:h})}n&&this.eventEmitter.emit("add",e,this)},t.Index.prototype.remove=function(t,e){var n=t[this._ref],e=void 0===e?!0:e;if(this.documentStore.has(n)){var i=this.documentStore.get(n);this.documentStore.remove(n),i.forEach(function(t){this.tokenStore.remove(t,n)},this),e&&this.eventEmitter.emit("remove",t,this)}},t.Index.prototype.update=function(t,e){var e=void 0===e?!0:e;this.remove(t,!1),this.add(t,!1),e&&this.eventEmitter.emit("update",t,this)},t.Index.prototype.idf=function(t){var e="@"+t;if(Object.prototype.hasOwnProperty.call(this._idfCache,e))return this._idfCache[e];var n=this.tokenStore.count(t),i=1;return n>0&&(i=1+Math.log(this.documentStore.length/n)),this._idfCache[e]=i},t.Index.prototype.search=function(e){var n=this.pipeline.run(this.tokenizerFn(e)),i=new t.Vector,r=[],o=this._fields.reduce(function(t,e){return t+e.boost},0),s=n.some(function(t){return this.tokenStore.has(t)},this);if(!s)return[];n.forEach(function(e,n,s){var a=1/s.length*this._fields.length*o,h=this,u=this.tokenStore.expand(e).reduce(function(n,r){var o=h.corpusTokens.indexOf(r),s=h.idf(r),u=1,l=new t.SortedSet;if(r!==e){var c=Math.max(3,r.length-e.length);u=1/Math.log(c)}o>-1&&i.insert(o,a*s*u);for(var f=h.tokenStore.get(r),d=Object.keys(f),p=d.length,v=0;p>v;v++)l.add(f[d[v]].ref);return n.union(l)},new t.SortedSet);r.push(u)},this);var a=r.reduce(function(t,e){return t.intersect(e)});return a.map(function(t){return{ref:t,score:i.similarity(this.documentVector(t))}},this).sort(function(t,e){return e.score-t.score})},t.Index.prototype.documentVector=function(e){for(var n=this.documentStore.get(e),i=n.length,r=new t.Vector,o=0;i>o;o++){var s=n.elements[o],a=this.tokenStore.get(s)[e].tf,h=this.idf(s);r.insert(this.corpusTokens.indexOf(s),a*h)}return r},t.Index.prototype.toJSON=function(){return{version:t.version,fields:this._fields,ref:this._ref,tokenizer:this.tokenizerFn.label,documentStore:this.documentStore.toJSON(),tokenStore:this.tokenStore.toJSON(),corpusTokens:this.corpusTokens.toJSON(),pipeline:this.pipeline.toJSON()}},t.Index.prototype.use=function(t){var e=Array.prototype.slice.call(arguments,1);e.unshift(this),t.apply(this,e)},t.Store=function(){this.store={},this.length=0},t.Store.load=function(e){var n=new this;return n.length=e.length,n.store=Object.keys(e.store).reduce(function(n,i){return n[i]=t.SortedSet.load(e.store[i]),n},{}),n},t.Store.prototype.set=function(t,e){this.has(t)||this.length++,this.store[t]=e},t.Store.prototype.get=function(t){return this.store[t]},t.Store.prototype.has=function(t){return t in this.store},t.Store.prototype.remove=function(t){this.has(t)&&(delete this.store[t],this.length--)},t.Store.prototype.toJSON=function(){return{store:this.store,length:this.length}},t.stemmer=function(){var t={ational:"ate",tional:"tion",enci:"ence",anci:"ance",izer:"ize",bli:"ble",alli:"al",entli:"ent",eli:"e",ousli:"ous",ization:"ize",ation:"ate",ator:"ate",alism:"al",iveness:"ive",fulness:"ful",ousness:"ous",aliti:"al",iviti:"ive",biliti:"ble",logi:"log"},e={icate:"ic",ative:"",alize:"al",iciti:"ic",ical:"ic",ful:"",ness:""},n="[^aeiou]",i="[aeiouy]",r=n+"[^aeiouy]*",o=i+"[aeiou]*",s="^("+r+")?"+o+r,a="^("+r+")?"+o+r+"("+o+")?$",h="^("+r+")?"+o+r+o+r,u="^("+r+")?"+i,l=new RegExp(s),c=new RegExp(h),f=new RegExp(a),d=new RegExp(u),p=/^(.+?)(ss|i)es$/,v=/^(.+?)([^s])s$/,g=/^(.+?)eed$/,m=/^(.+?)(ed|ing)$/,y=/.$/,S=/(at|bl|iz)$/,w=new RegExp("([^aeiouylsz])\\1$"),k=new RegExp("^"+r+i+"[^aeiouwxy]$"),x=/^(.+?[^aeiou])y$/,b=/^(.+?)(ational|tional|enci|anci|izer|bli|alli|entli|eli|ousli|ization|ation|ator|alism|iveness|fulness|ousness|aliti|iviti|biliti|logi)$/,E=/^(.+?)(icate|ative|alize|iciti|ical|ful|ness)$/,F=/^(.+?)(al|ance|ence|er|ic|able|ible|ant|ement|ment|ent|ou|ism|ate|iti|ous|ive|ize)$/,_=/^(.+?)(s|t)(ion)$/,z=/^(.+?)e$/,O=/ll$/,P=new RegExp("^"+r+i+"[^aeiouwxy]$"),T=function(n){var i,r,o,s,a,h,u;if(n.length<3)return n;if(o=n.substr(0,1),"y"==o&&(n=o.toUpperCase()+n.substr(1)),s=p,a=v,s.test(n)?n=n.replace(s,"$1$2"):a.test(n)&&(n=n.replace(a,"$1$2")),s=g,a=m,s.test(n)){var T=s.exec(n);s=l,s.test(T[1])&&(s=y,n=n.replace(s,""))}else if(a.test(n)){var T=a.exec(n);i=T[1],a=d,a.test(i)&&(n=i,a=S,h=w,u=k,a.test(n)?n+="e":h.test(n)?(s=y,n=n.replace(s,"")):u.test(n)&&(n+="e"))}if(s=x,s.test(n)){var T=s.exec(n);i=T[1],n=i+"i"}if(s=b,s.test(n)){var T=s.exec(n);i=T[1],r=T[2],s=l,s.test(i)&&(n=i+t[r])}if(s=E,s.test(n)){var T=s.exec(n);i=T[1],r=T[2],s=l,s.test(i)&&(n=i+e[r])}if(s=F,a=_,s.test(n)){var T=s.exec(n);i=T[1],s=c,s.test(i)&&(n=i)}else if(a.test(n)){var T=a.exec(n);i=T[1]+T[2],a=c,a.test(i)&&(n=i)}if(s=z,s.test(n)){var T=s.exec(n);i=T[1],s=c,a=f,h=P,(s.test(i)||a.test(i)&&!h.test(i))&&(n=i)}return s=O,a=c,s.test(n)&&a.test(n)&&(s=y,n=n.replace(s,"")),"y"==o&&(n=o.toLowerCase()+n.substr(1)),n};return T}(),t.Pipeline.registerFunction(t.stemmer,"stemmer"),t.generateStopWordFilter=function(t){var e=t.reduce(function(t,e){return t[e]=e,t},{});return function(t){return t&&e[t]!==t?t:void 0}},t.stopWordFilter=t.generateStopWordFilter(["a","able","about","across","after","all","almost","also","am","among","an","and","any","are","as","at","be","because","been","but","by","can","cannot","could","dear","did","do","does","either","else","ever","every","for","from","get","got","had","has","have","he","her","hers","him","his","how","however","i","if","in","into","is","it","its","just","least","let","like","likely","may","me","might","most","must","my","neither","no","nor","not","of","off","often","on","only","or","other","our","own","rather","said","say","says","she","should","since","so","some","than","that","the","their","them","then","there","these","they","this","tis","to","too","twas","us","wants","was","we","were","what","when","where","which","while","who","whom","why","will","with","would","yet","you","your"]),t.Pipeline.registerFunction(t.stopWordFilter,"stopWordFilter"),t.trimmer=function(t){return t.replace(/^\W+/,"").replace(/\W+$/,"")},t.Pipeline.registerFunction(t.trimmer,"trimmer"),t.TokenStore=function(){this.root={docs:{}},this.length=0},t.TokenStore.load=function(t){var e=new this;return e.root=t.root,e.length=t.length,e},t.TokenStore.prototype.add=function(t,e,n){var n=n||this.root,i=t.charAt(0),r=t.slice(1);return i in n||(n[i]={docs:{}}),0===r.length?(n[i].docs[e.ref]=e,void(this.length+=1)):this.add(r,e,n[i])},t.TokenStore.prototype.has=function(t){if(!t)return!1;for(var e=this.root,n=0;n<t.length;n++){if(!e[t.charAt(n)])return!1;e=e[t.charAt(n)]}return!0},t.TokenStore.prototype.getNode=function(t){if(!t)return{};for(var e=this.root,n=0;n<t.length;n++){if(!e[t.charAt(n)])return{};e=e[t.charAt(n)]}return e},t.TokenStore.prototype.get=function(t,e){return this.getNode(t,e).docs||{}},t.TokenStore.prototype.count=function(t,e){return Object.keys(this.get(t,e)).length},t.TokenStore.prototype.remove=function(t,e){if(t){for(var n=this.root,i=0;i<t.length;i++){if(!(t.charAt(i)in n))return;n=n[t.charAt(i)]}delete n.docs[e]}},t.TokenStore.prototype.expand=function(t,e){var n=this.getNode(t),i=n.docs||{},e=e||[];return Object.keys(i).length&&e.push(t),Object.keys(n).forEach(function(n){"docs"!==n&&e.concat(this.expand(t+n,e))},this),e},t.TokenStore.prototype.toJSON=function(){return{root:this.root,length:this.length}},function(t,e){"function"==typeof define&&define.amd?define(e):"object"==typeof exports?module.exports=e():t.lunr=e()}(this,function(){return t})}();